/***************************************************************************
 * GLOBALS.H
 ***************************************************************************/

/*----------------------------------------------------------------------------*
 * These are key hooks into the Host's and Leach's screens and windows,
 * which are available to all parts of the program. They are declared in 
 * main.c and defined in other files that need access to them.
 *----------------------------------------------------------------------------*/

GLOBAL char				*HostTitle;	/* Pointer to target screen title.		*/
									/* Determined by default or user input.	*/
GLOBAL struct Screen    *HostScreen;
GLOBAL struct Window	*HostWind;		/* Host's primary window			*/
GLOBAL struct Menu		*HostMenuStrip; /* 1st Host menu.					*/
GLOBAL struct RastPort	*HostRPort;		/* Taken from Host's window			*/
GLOBAL struct MsgPort	*HostUPort;		/* Host window's UserPort			*/
GLOBAL struct Task		*HostTask;		/* Taken from Host's UserPort		*/
GLOBAL ULONG			HostFlags;		/* The unadulterated flags.			*/
GLOBAL ULONG			HostIDCMPflags;	/* The unadulterated flags.			*/
GLOBAL ULONG			HostVERflags;	/* IDCMP flags for verifications.	*/
GLOBAL UBYTE			HostSig;		/* Taken from Host's UserPort		*/
GLOBAL UBYTE			H_quit_menu;	/* Menu and item #'s of Host's QUIT	*/
GLOBAL UBYTE			H_quit_item;	/* menu selection.					*/
GLOBAL UBYTE			H_found_quit;	/* Quit Host menu item exists flag.	*/
GLOBAL short			charwidth;		/* Host's text dimentions.			*/
GLOBAL short			charheight;		/* Taken from Host's RastPort		*/

GLOBAL struct Screen	*StatScreen;	/* Leach's status display screen	*/
GLOBAL struct Window	*StatWind;		/* Leach's borderless status window.*/
GLOBAL struct RastPort	*StatRPort;		/* For Leach's status screen.		*/
GLOBAL struct ViewPort	*StatVP;		/* For Leach's status screen.		*/
GLOBAL struct Task		*LeachTask;	
GLOBAL UBYTE			L_menu_num;		/* Leach menu's position in the		*/
GLOBAL UBYTE			L_menuitem_num;	/* Host's menustrip.				*/
GLOBAL UBYTE			LeachSig;

GLOBAL ULONG			HostIDCMPmods;	/* The flags that Leach has set.	*/
GLOBAL ULONG			HostFlagsmods;	

/*----------------------------------------------------------------------*
 * HostIPort holds the address of the message port that Intuition expects
 * messages sent to the Host to be Replied to. This address is picked out
 * of the first msg that Intuition sends. From that point on, checkmsg()
 * will substitute the address of MyPort in these messages. Thus, the Host
 * will return IntuiMessages to Leach, which will restore the Intuition
 * port's address and return. All this means that Leach can tell if it
 * has processed a msg in the Host's queue by the ReplyPort address.
 *----------------------------------------------------------------------*/

GLOBAL struct MsgPort	*HostIPort;
GLOBAL struct MsgPort	*MyPort;
GLOBAL UBYTE			MySig;
